#!/usr/bin/env python3

import test_xy
import test_xz
import test_xz_cfbc
import test_xz_halfar
import test_xz_vanderveen

def main(header=False):
    print("// DO NOT EDIT. This code was generated by a Python script.")

    if header:
        print('#include "pism/util/Vector2d.hh"')
    else:
        print("#include <cmath>")
        print("")
        print('#include "manufactured_solutions.hh"')

    print("")
    print("namespace pism {")

    test_xy.print_code(header)
    test_xz.print_code(header)
    test_xz_cfbc.print_code(header)
    test_xz_halfar.print_code(header)
    test_xz_vanderveen.print_code(header)

    print("")
    print("} // end of namespace pism")

if __name__ == "__main__":
    from argparse import ArgumentParser

    parser = ArgumentParser()
    parser.add_argument("--header", dest="header", action="store_true",
                        help="print function declarations for the header file")

    options = parser.parse_args()

    main(options.header)
